#pragma once
#ifndef _SN79489_H
#define _SN79489_H


#include <boost/cstdint.hpp>
#include <boost/shared_ptr.hpp>

typedef boost::uint8_t UBYTE ;
typedef boost::int8_t SBYTE ;
typedef boost::uint16_t UWORD ;
typedef boost::int16_t SWORD ;
typedef boost::uint32_t UDWORD ;
typedef boost::int32_t SDWORD ;
typedef boost::uint64_t UQWORD ;
typedef boost::int64_t SQWORD ;

class SN79489
{
public:
	static boost::shared_ptr<SN79489> Create( ) ;
								~SN79489				(void);

			void				WriteData				( unsigned long int cycles, UBYTE data ) ;
			void				Reset					( ) ;
			void				Update					( float cycles ) ;
			SWORD*				GetPlayBuffer			( )  ;
			int					GetFrequency			( ) const ;
			UWORD				GetBufferSize			( ) const ;
			void				PlaybackCompleted		( ) ;
private:
								SN79489					(void);
	enum CHANNEL
	{
		CHANNEL_ZERO,
		CHANNEL_ONE,
		CHANNEL_TWO,
		CHANNEL_THREE,
		CHANNEL_NUM
	} ;

	enum TONES
	{
		TONES_ZERO,
		TONES_ONE,
		TONES_TWO,
		TONES_NOISE,
		TONES_NUM
	};

	enum VOLUME
	{
		VOLUME_ZERO,
		VOLUME_ONE,
		VOLUME_TWO,
		VOLUME_THREE,
		VOLUME_NUM
	};
	
	static	const UWORD				BUFFERSIZE = 1024 ;
	static	const int				FREQUENCY = 44100;
			SWORD					m_Buffer[BUFFERSIZE] ;
			UWORD					m_Tones[TONES_NUM] ;
			UBYTE					m_Volume[VOLUME_NUM] ;
			int						m_Counters[CHANNEL_NUM] ;
			int						m_Polarity[CHANNEL_NUM] ;
			CHANNEL					m_LatchedChannel ;
			bool					m_IsToneLatched ;
			int						m_VolumeTable[16] ;
			int						m_CurrentBufferPos ;
			float					m_Cycles ;
			UWORD					m_LFSR ;
			unsigned long int		m_ClockInfo ;
			float					m_BufferUpdateCount ;
			float					m_UpdateBufferLimit ;
};

#endif 
