#include "Config_cs_core.h"
#include "IniFiles.h"

namespace codeslinger
{
	namespace inifile
	{
		/////////////////////////////////////////////////////////////////////////

		boost::shared_ptr<IniFileReader> IniFileLoadSettings( 
			const std::string& settingName, const std::string& filename)
		{
			boost::shared_ptr<IniFileReader> res = boost::shared_ptr<IniFileReader>( 
				new IniFileReader("Config", filename) ) ;
			IniFileManager::GetSingletonPtr()->AddIniFile(settingName, res) ;
			return res ;
		}

		/////////////////////////////////////////////////////////////////////////

		IniFileManager* IniFileCreateManager( )
		{
			return IniFileManager::CreateSingleton( ) ;
		}

		/////////////////////////////////////////////////////////////////////////

		void IniFileDestroyManager( )
		{
			IniFileManager::DestroySingleton( ) ;
		}

		/////////////////////////////////////////////////////////////////////////
	};
};