#pragma once
#ifndef _CS_LOG_FILE_H
#define _CS_LOG_FILE_H

#include "LogMsgDestination.h"
#include <string>
#include <vector>
#include <fstream>
#include <boost/shared_ptr.hpp>

namespace codeslinger
{
	namespace logging
	{
		class LogMsgDestination;

		class Logfile : public LogMsgDestination
		{
		public:
			Logfile( ) ;
			explicit Logfile(const std::string& filename);
			virtual ~Logfile(void);

			void AddDestination( const boost::shared_ptr<LogMsgDestination>& destination ) ;
			void LogMessage( const std::string& message ) ;
			bool IsEnabled( ) const ;
			int GetLevel( ) const ;
			std::string GetName( ) const ;

		private:

			virtual void ProcessMessage( const std::string& message ) ; // use logmessage instead

			typedef std::vector< boost::shared_ptr<LogMsgDestination> > DESTINATIONS ;
			DESTINATIONS m_Destinations ;
			std::ofstream m_File ;
			bool m_Enabled ;
			int m_Level ;
			std::string m_Name ;
		};
	};
};

#endif