#pragma once
#ifndef _CS_LOGGING_H
#define _CS_LOGGING_H

#include "LogMsgDestination.h"
#include <string>
#include <boost/shared_ptr.hpp>

namespace codeslinger
{
	namespace logging
	{
		void LoggingCreateManager( ) ;
		void LoggingDestroyManager( ) ;
		void LoggingAddNewGroup( const std::string& groupName ) ;
		void LoggingAddNewSubset( const std::string& subset) ;
		void LoggingAddDestination( const std::string& groupName, const std::string& sybset, 
			const boost::shared_ptr<LogMsgDestination>& dest ) ;
		void LoggingChainLogFiles( const std::string& source, const std::string& destination ) ;
		bool LoggingDoesLogFileExist( const std::string& groupName, const std::string& subset ) ;		
		void LogMessage( const std::string& groupName, 
			const std::string& subset, int level, const std::string& msg ) ;
		void LogMessage( const std::string& subset, const std::string& msg ) ;
		void LogMessage( const std::string& groupName, const std::string& subset, 
			const std::string& msg ) ;
		void LogMessage( const std::string& subset, int level, const std::string& msg ) ;

	};
};

#endif