#include "Config_cs_core.h"
#include "StringHelpers.h"
#include <algorithm>

namespace codeslinger
{
	namespace string
	{
		std::string RemoveTrailingSpace( const std::string& str )
		{
			std::string res = str ;
			size_t pos = res.find_last_not_of( ' ' ) ;
			if (pos != std::string::npos)
			{
				res.erase( res.begin() + pos + 1, res.end() ) ;
			}
			return res ;
		}

		std::string CompactSpaces( const std::string& str )
		{
			std::string res = str ;
			size_t pos = res.find("  ") ;
			
			while(pos != std::string::npos)
			{
				res.erase( res.begin() + pos, res.begin() + pos + 1 ) ;
				pos = res.find("  ") ;
			}
			return res ;
		}

		std::string NukeSpaces( const std::string& str )
		{
			std::string res = str ;
			res = RemoveTrailingSpace(res) ;
			res = CompactSpaces(res) ;
			return res ;
		}
	};
};