#ifndef _CI_STRING_H
#define _CI_STRING_H

#pragma warning(disable:4996)

#include <string>

namespace codeslinger
{
	namespace string
	{
		struct ci_char_traits : public std::char_traits<char> 
			// just inherit all the other functions
			//  that we don't need to replace
		{
			static bool eq( char c1, char c2 )
			{ return toupper(c1) == toupper(c2); }
			static bool lt( char c1, char c2 )
			{ return toupper(c1) <  toupper(c2); }
			static int compare( const char* s1,
				const char* s2,
				size_t n )
			{ return _memicmp( s1, s2, n ); }
			// if available on your platform,
			//  otherwise you can roll your own
			static const char*
				find( const char* s, int n, char a )
			{
				while( n-- > 0 && toupper(*s) != toupper(a) )
				{
					++s;
				}
				return n >= 0 ? s : 0;
			}
		};

		typedef std::basic_string<char, ci_char_traits> ci_string;
	};
};
#endif