#include "Config_cs_core.h"
#include <boost/cstdint.hpp>
#include "Maths.h"

namespace codeslinger
{
	namespace maths
	{
		//////////////////////////////////////////////////////////////////////////////////

		void SwapEndian( boost::uint16_t& toSwap ) 
		{
			boost::uint16_t highByte = ((toSwap & 0xff) <<8) ;
			boost::uint16_t lowByte = ((toSwap & 0xff00) >> 8) ;
			toSwap = highByte | lowByte ;
		}

		//////////////////////////////////////////////////////////////////////////////////

		void SwapEndian( boost::uint32_t& toSwap ) 
		{
			boost::uint32_t byte1 = toSwap & 0xFF ;
			boost::uint32_t byte2 = (toSwap >> 8) & 0xFF;
			boost::uint32_t byte3 = (toSwap >> 16) & 0xFF ;
			boost::uint32_t byte4 = (toSwap >> 24) & 0xFF ;

			toSwap = ( (byte1 << 24 ) | (byte2 << 16)) | ( (byte3 << 8) | byte4) ;
			//	toSwap = ( (byte1 << 24 ) | (byte2 << 16)) | ( (byte4 << 8) | byte3) ;
		}
	};
};