#ifndef _CS_SINGLETON_H
#define _CS_SINGLETON_H

#include "Debugging.h"

namespace codeslinger
{
	template <typename T>
	class Singleton
	{
	public:

		static T* CreateSingleton ( )
		{
			if (m_Instance == 0)
			{
				Singleton<T>::m_Instance = new T ;
			}
			else
			{
				// you really should be calling GetSingletonPtr
				ASSERT(false) ;
			}
			return m_Instance ;
		}

		static T* GetSingletonPtr ( )
		{
			if (Singleton<T>::m_Instance == 0)
			{
				ASSERT(false) ;
			}
			return Singleton<T>::m_Instance ;
		}

		static void	DestroySingleton ( )
		{
			if (Singleton<T>::m_Instance != 0)
			{
				delete Singleton<T>::m_Instance ;
				Singleton<T>::m_Instance = 0 ;
			}
		}

	protected:
		  virtual           ~Singleton  ( ) { }
							Singleton	( ) ;

	private:
		static	T*			m_Instance ;

				// make it non copyable
				T&			operator =	(const T& nc) ;
							Singleton	(const Singleton& nc) ;
	};

	template <typename T> T* Singleton<T>::m_Instance = 0 ;

	template <typename T> Singleton<T>::Singleton( )
	{
		// remember to make the class that derives from singleton have
		// private constructors and destructors, but make sure that you
		// declare the singleton class as a friend. i.e
		// friend class CodeSlinger::Singleton<derivedClass> ;
		if (Singleton<T>::m_Instance != 0)
		{
			ASSERT(false) ;
		}

	};
};

#endif
