#include "Config_cs_core.h"
#include "Throw.h"
#include "../Logging/LoggingManager.h"
#include <boost/format.hpp>

namespace codeslinger
{
	namespace error
	{
		void Throw( const std::string& where, const std::string& what )
		{
			std::string msg = ( boost::format("Exception thrown at: %1%: Cause: %2%") % where % what ).str() ;
			
			codeslinger::logging::LoggingManager* logMan = codeslinger::logging::LoggingManager::GetSingletonPtr() ;
			if (logMan)
			{
				logMan->LogMessage("Main", "err", 0, msg) ; 
			}
			throw std::runtime_error( msg ) ;
		}
	};
};