#include "Config_MegaDrive.h"
#include "SDLAudioDevice.h"
#include <SDL/SDL.h>

/////////////////////////////////////////////////////////////////////////////////

SDLAudioDevice::PTR SDLAudioDevice::Create()
{
	return PTR( new SDLAudioDevice() ) ;
}

/////////////////////////////////////////////////////////////////////////////////

SDLAudioDevice::SDLAudioDevice(void)
	: m_buffer(NULL)
	, m_Complete(true)
{
}
/////////////////////////////////////////////////////////////////////////////////

void SDLAudioDevice::Initialise( SWORD* buffer, int freq, UWORD bufferSize )
{
	m_buffer = buffer;
	m_Complete = true;
	SDL_CloseAudio( ) ;
	SDL_AudioSpec as;
	as.freq = freq;
	as.format = AUDIO_S16SYS;
	as.channels = 1;
	as.silence = 0;
	as.samples = bufferSize ;
	as.size = 0;
	as.callback = HandleSDLCallback ;
	as.userdata = this;
	SDL_OpenAudio( &as, 0 ) ;
	SDL_PauseAudio( 0 );
}

/////////////////////////////////////////////////////////////////////////////////

SDLAudioDevice::~SDLAudioDevice(void)
{
}

/////////////////////////////////////////////////////////////////////////////////

void SDLAudioDevice::HandleSDLCallback( void* userData, UBYTE* buffer, int len )
{
	SDLAudioDevice* data = (SDLAudioDevice*)userData ;
	data->HandleSDLCallback(buffer, len) ;
}

/////////////////////////////////////////////////////////////////////////////////

void SDLAudioDevice::HandleSDLCallback( UBYTE* buffer, int len )
{
	memcpy( buffer, m_buffer, len );
	m_Complete = true ;
}

/////////////////////////////////////////////////////////////////////////////////

bool SDLAudioDevice::IsPlaybackComplete() const
{
	return m_Complete;
}

/////////////////////////////////////////////////////////////////////////////////

void SDLAudioDevice::Play( SWORD* buffer )
{
	m_Complete = false ;
}

/////////////////////////////////////////////////////////////////////////////////
