#pragma once
#ifndef _MDDEBUGGER_H
#define _MDDEBUGGER_H

#include <boost/shared_ptr.hpp>
class MegaDrive;
class iInputDevice;
#ifndef ENABLE_DEBUGGER

class MDDebugger
{
public:
	void Update( ) {}
};

#else

class MDDebugger
{
public:
	enum DEBUG_KEYS
	{
		DEBUG_DUMP_VRAM,
		DEBUG_TOGGLE_LOGGING_ENABLED,
		DEBUG_PAUSE,
		DEBUG_NUM
	};
	MDDebugger(const boost::shared_ptr<MegaDrive>& megaDrive, const boost::shared_ptr<iInputDevice>& input);
	void Update( ) ;
private:
	void HandleKeyEvent(bool down, int id);

	boost::shared_ptr<MegaDrive> m_MegaDrive;
	boost::shared_ptr<iInputDevice> m_InputDrive;
};

#endif

#endif