#include "Config_MegaDrive.h"
#include "InputSDLWindow.h"
#include <SDL/SDL.h>

/////////////////////////////////////////////////////////////////////////////////

InputSDLWindow::PTR InputSDLWindow::Create()
{
	return InputSDLWindow::PTR( new InputSDLWindow() ) ;
}

/////////////////////////////////////////////////////////////////////////////////

InputSDLWindow::InputSDLWindow(void)
{
}

/////////////////////////////////////////////////////////////////////////////////

InputSDLWindow::~InputSDLWindow(void)
{
}

/////////////////////////////////////////////////////////////////////////////////

bool InputSDLWindow::Update()
{
	SDL_PumpEvents( ) ;

	const int c_maxevents = 10 ;
	SDL_Event events[c_maxevents] ;

	const int c_numevents = SDL_PeepEvents( events, c_maxevents, SDL_PEEKEVENT, 
		SDL_EVENTMASK(SDL_KEYUP) | SDL_EVENTMASK(SDL_KEYDOWN) ) ;

	for ( int i = 0; i < c_numevents; ++i)
	{
		const SDL_Event& c_event = events[i] ;

		if( c_event.type == SDL_KEYDOWN )
		{
			std::map<int,int>::const_iterator it = m_KeyMap.find( c_event.key.keysym.sym ) ;
			if ( it != m_KeyMap.end() )
			{
				m_FuncKeyPress(true, (*it).second);
			}
		}
		else if( c_event.type == SDL_KEYUP )
		{
			std::map<int,int>::const_iterator it = m_KeyMap.find( c_event.key.keysym.sym ) ;
			if ( it != m_KeyMap.end() )
			{
				m_FuncKeyPress(false, (*it).second);
			}
		}
	}
	return true;
}

/////////////////////////////////////////////////////////////////////////////////

void InputSDLWindow::MapKey( int deviceKey, int keyToMap )
{
	m_KeyMap.insert( std::make_pair(keyToMap, deviceKey) ) ;
}

/////////////////////////////////////////////////////////////////////////////////

void InputSDLWindow::SetFunctionKeyPress( const boost::function<void ( bool, int )>& func )
{
	m_FuncKeyPress = func;
}

/////////////////////////////////////////////////////////////////////////////////