#ifndef _iINPUT_DEVICE_H
#define _iINPUT_DEVICE_H

#include <boost/shared_ptr.hpp>
#include <boost/function.hpp>

class iInputDevice
{
public:
	typedef boost::shared_ptr<iInputDevice> PTR ;

	virtual ~iInputDevice(void) {} ;

	virtual bool Update( ) = 0 ;
	virtual void MapKey( int deviceKey, int keyToMap ) = 0 ;
	virtual void SetFunctionKeyPress( const boost::function<void ( bool, int )>& func ) = 0 ;

protected:
	iInputDevice(void) {}
};

#endif