#pragma once
#ifndef _YM2616_H
#define _YM2616_H

#include <boost/cstdint.hpp>
#include <boost/shared_ptr.hpp>

typedef boost::uint8_t UBYTE ;
typedef boost::int8_t SBYTE ;
typedef boost::uint16_t UWORD ;
typedef boost::int16_t SWORD ;
typedef boost::uint32_t UDWORD ;
typedef boost::int32_t SDWORD ;
typedef boost::uint64_t UQWORD ;
typedef boost::int64_t SQWORD ;

class YM2616
{
public:
	static boost::shared_ptr<YM2616> Create( ) ;
	
	void Update( int cycles );

	UBYTE ReadData( ) const ;
	void WriteAddressPart1( UBYTE address ) ;
	void WriteAddressPart2( UBYTE address ) ;
	void WriteDataPart1( UBYTE data ) ;
	void WriteDataPart2( UBYTE data ) ;

private:
	YM2616();
};

#endif 
